/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 17.06.2013
Author  : NeVaDa
Company : 
Comments: 


Chip type               : ATmega16
Program type            : Application
AVR Core Clock frequency: 11,059200 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega16.h>
#include <delay.h>

// 1 Wire Bus interface functions
#include <1wire.h>

// DS1820 Temperature Sensor functions
#include <ds18b20.h>

unsigned char nom=0; //   
unsigned int nom1=0;//      
unsigned int nom2=0;///////////,.......
unsigned int nom3=0;///...........
unsigned int nom4=0;
unsigned int nom5=0;
unsigned int nom6=0;
unsigned char i=0;//       .
bit minus=0; 
// Timer 0 output compare interrupt service routine
interrupt [TIM0_COMP] void timer0_comp_isr(void)
{
//      
    PORTC=0x00;//   
              
    switch (i)
        { 
            // 
            case 0:PORTC.0=1;nom=nom1;i++;break;//   0,  0  ...
            case 1:PORTC.1=1;nom=nom2;i++;break;//   1,   1,  ...
            case 2:PORTC.2=1;nom=nom3;i++;break;
            case 3:PORTC.3=1;nom=nom4;i++;break;
            case 4:PORTC.4=1;nom=nom5;i++;break;
            case 5:PORTC.5=1;nom=nom6;i=0;break;
        }
    if(i==3)
        {    
            switch(nom)//     ..
            { 
                //   ...
                case 0:{PORTB=0xbf;break;}//  ( )  =0   0  ...
                case 1:{PORTB=0x86;break;}
                case 2:{PORTB=0xdb;break;}
                case 3:{PORTB=0xcf;break;}
                case 4:{PORTB=0xe6;break;}
                case 5:{PORTB=0xed;break;}
                case 6:{PORTB=0xfd;break;}
                case 7:{PORTB=0x87;break;}
                case 8:{PORTB=0xff;break;}
                case 9:{PORTB=0xef;break;}
                case 10:{PORTB=0x63;break;}// ...
                case 11:{PORTB=0x39;break;}//
                case 12:{PORTB=0x00;break;}// 
                case 13:{PORTB=0x40;break;}//
            }
        } 
        else
        {
            switch (nom)
            { 
            //   
                case 0:{PORTB=0x3f;break;}//  ( )  =0   0  ...
                case 1:{PORTB=0x06;break;}
                case 2:{PORTB=0x5b;break;}
                case 3:{PORTB=0x4f;break;}
                case 4:{PORTB=0x66;break;}
                case 5:{PORTB=0x6d;break;}
                case 6:{PORTB=0x7d;break;}
                case 7:{PORTB=0x07;break;}
                case 8:{PORTB=0x7f;break;}
                case 9:{PORTB=0x6f;break;}
                case 10:{PORTB=0x63;break;}
                case 11:{PORTB=0x39;break;}
                case 12:{PORTB=0x00;break;} // 
                case 13:{PORTB=0x40;break;}//
            }
       }
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here
float temper;
unsigned int x;
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=T State3=T State2=0 State1=0 State0=0 
PORTA=0x00;
DDRA=0x07;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0xff;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 10,800 kHz
// Mode: CTC top=OCR0
// OC0 output: Disconnected
TCCR0=0x0D;
TCNT0=0x00;
OCR0=0x14;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// 1 Wire Bus initialization
// 1 Wire Data port: PORTD
// 1 Wire Data bit: 7
// Note: 1 Wire port settings must be specified in the
// Project|Configure|C Compiler|Libraries|1 Wire IDE menu.
w1_init();
ds18b20_init(0,-20,50,DS18B20_12BIT_RES);
// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here
        temper=ds18b20_temperature(0);
        if (temper>1000)
            {
                temper=4096.0-temper;
                minus=1;
            }
       
      x=temper*10;
      nom4=x%10;//     ...
      x=x/10;
      nom3=x%10;
      nom2=x/10;
      nom5=10;
      nom6=11;
        if(minus==0)
            {
            nom1=12;
            }
        else
            {
            nom1=13;
            } 
      }
}
